unit rDBGridSorter_AbsDB;

{<
  rDBGridSorter_AbsDB unit contains TrDBGridSorter_AbsDB - sorter for TABSTable
  used by rDBGrid to sort ABS datasets.

  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(Apr 2020)
  @lastmod(Apr 2020)
}

interface

uses
  Windows, Messages, SysUtils, Graphics, Classes, Controls, Menus, Dialogs,
  StdCtrls, Forms, DB, Variants, rDBGrid,
  ABSMain;

type
  { sorter for TABSTable used by rDBGrid to sort ABS datasets }
  TrDBGridSorter_AbsDB = class(TrDBGridCustomSorter)
  public
    function SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string): boolean; override;
  end;

procedure Register;

implementation

{$R *.res}
uses RosiCompGlobalCfg;

procedure Register;
begin
  RegisterComponents('Rosi DB', [TrDBGridSorter_AbsDB]);
end;

function TrDBGridSorter_AbsDB.SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string)
  : boolean;
var
  DS: TABSTable;
  idxName: string;
begin
  if (DataSet is TABSTable) then
  begin
    DS:=DataSet as TABSTable;
    if Trim(SortFields)='' then
      DS.IndexName:=''
    else
    begin
      idxName:=SortFields + '_' + DescendingFields;
      if DS.IndexDefs.IndexOf(idxName) < 0 then
        DS.AddIndex(idxName, SortFields, [], DescendingFields);
      DS.IndexDefs.Update;
      DS.IndexName:=idxName;
    end;
    Result:=true;
  end
  else
    Result:= inherited;
end;

end.
